%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This program filter out the non-exist records in the soundlist 
% based on the query conditions.
% Input: sndlist_in - the list of utterances available for the experiment
%        cur_tlk - the current talker, '' for all talkers
%        cur_con - the current consonant, '' for all
%        cur_vow - the current vowel, '' for all
% Return: sndlist_out - the records in sndlist_in that related to cur_tlk, 
%        cur_con and cur_vow.
%   Author:      Feipeng Li
%   E-mail:      fli2@uiuc.edu
%   Time-stamp:  2007-06-05
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function sndlist_out = query_sndlist( sndlist_in, cur_tlk, cur_con, cur_vow)

tf1 = ones(size(sndlist_in.tlk));
tf2 = ones(size(sndlist_in.con));
tf3 = ones(size(sndlist_in.vow));

if ~isempty(cur_tlk)
    tf1 = strcmp(sndlist_in.tlk, cur_tlk);
end

if ~isempty(cur_con)
    tf2 = strcmp(sndlist_in.con, cur_con);
end

if ~isempty(cur_vow)
    tf3 = strcmp(sndlist_in.vow, cur_vow);
end

tf = tf1.*tf2.*tf3; p = find(tf);
sndlist_out.tlk = {sndlist_in.tlk{p}};
sndlist_out.con = {sndlist_in.con{p}};
sndlist_out.vow = {sndlist_in.vow{p}};