%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This program update the plots of of GUI window
% Input: handles -- the handle to the window
%        list_view -- a list of the plots that need to be updated 
%        {'ai', 'cc', 'event', 'pi', 'mod1', 'mod2'}
%   Author:      Feipeng Li
%   E-mail:      fli2@uiuc.edu
%   Time-stamp:  2007-06-12
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function updateviews(handles, list_view)

str_list_view = list_view{1};
for i=2:length(list_view)
    str_list_view = [str_list_view '_' list_view{i}];
end

global doc; % contains all the data
% show event_gram
if (strfind(str_list_view, 'event')) 
    axes(handles.plotEventGram); cla;  %position; 
    plot_event_gram(doc.eventgram, doc.fname, doc.snr, doc.time, doc.exp);
end

% show cc
if (strfind(str_list_view, 'cc')) 
    axes(handles.plotCC); cla; %position; 
    plot_cc(doc.cc, doc.fname, doc.snr, doc.time, doc.exp);
    cursCC = mycursors(handles.plotCC);
end

% show AIgram
if (strfind(str_list_view, 'ai')) 
    axes(handles.plotAIgram); cla; %position; 
    plot_AI_gram(doc.aigram, doc.fname, doc.snr, doc.time, doc.exp);
    %plot_AI_gram(doc.aigram, doc.fname, doc.snr, 'novalue', doc.exp);
    
    start_time = min(doc.aigram.time_axis);
    end_time = max(doc.aigram.time_axis);
    time_axis_cs = round(10000*doc.aigram.time_axis)/100;
    t_star_col = round((doc.time-start_time)/(end_time-start_time)*length(doc.aigram.time_axis));    
    
    htmp = figure('Position',[50, 50, 400, 300], 'Visible', 'off');
    set(htmp,'PaperPositionMode','auto')
    plot_AI_gram(doc.aigram, doc.fname, doc.snr, 'novalue', doc.exp);
    print(htmp,'-depsc2', 'AI_gram_loaded');
    close(htmp);    
     
%     cursAI = mycursors(handles.plotAIgram, 'r');
%     
%     %cursAI = mycursors(handles.plotAIgram);
%     
%     % Execute code only if at least one cursor has already been added
%     if ~isempty(cursAI)
%       cursAI.add(t_star_col, time_axis_cs);        
%       pos = cursAI.val(1);     % Get cursors positions
%     end
end

% show CP
if (strfind(str_list_view, 'pi')) 
    axes(handles.plotPI); cla; %position; 
    plot_cp(doc.cp, doc.snr, doc.exp);
    
    htmp = figure('Position',[50, 50, 400, 300], 'Visible', 'off');
    set(htmp,'PaperPositionMode','auto')
    plot_cp(doc.cp, doc.snr, doc.exp);
    print(htmp,'-depsc2', 'cp');
    close(htmp);    
    
end

% show AIgram at Mod 1
if (strfind(str_list_view, 'mod1')) 
    axes(handles.plotMod1); cla reset; %position; 
    %figure;
    plot_AI_gram(doc.mod1.cur_aigram, doc.mod1.wavfile, doc.mod1.snr, doc.mod1.stime, doc.mod1.etime, doc.mod1.freqlow, doc.mod1.freqhigh);
    for i=1:length(doc.mod1.regs)
        
        xy = doc.mod1.regs{i}.pos;
        g = doc.mod1.regs{i}.gain;

        doc.mod1.regs{i}.patch = plot_patch(xy, g); hold on;

        [nrow, ncol] = size(doc.mod1.regs{i}.pos);
        if nrow>2
            if g==0
                colorcode = [0 0 1]; % blue when gain = 0;
            elseif (g>0)&&(g<=1)
                colorcode = [0 1 0]; % ? when gain between 0 and 1;
            elseif (g>1)&&(g<=10)
                colorcode = [1 1 0]; % gree when gain between 1 and 10;
            elseif (g>10)
                colorcode = [1 0 0]; % gree when gain between 1 and 10;
            end

            x_center = (max(doc.mod1.regs{i}.pos(1,:)) + min(doc.mod1.regs{i}.pos(1,:)))/2;
            y_center = (max(doc.mod1.regs{i}.pos(2,:)) + min(doc.mod1.regs{i}.pos(2,:)))/2;        
            
            xi = doc.mod1.regs{i}.pos(3,1);  yi = doc.mod1.regs{i}.pos(3,2);
            
            doc.mod1.regs{i}.patch(2:3) = plot_arrow(x_center, y_center, xi, yi, 'linewidth',2,'color',colorcode,'facecolor',colorcode,'edgecolor',colorcode);        
        end
        
        if (doc.mod1.regs{i}.onoff)
            set(doc.mod1.regs{i}.patch, 'visible', 'on'); 
        else
            set(doc.mod1.regs{i}.patch, 'visible', 'off');
        end
    end
    
    % save the mod1 in an eps figure
    htmp = figure('Position',[50, 50, 400, 300], 'Visible', 'off');
    %htmp = figure('Position',[50, 50, 400, 300]);
    set(htmp,'PaperPositionMode','auto')
    plot_AI_gram(doc.mod1.cur_aigram, doc.mod1.wavfile, doc.mod1.snr, doc.mod1.stime, doc.mod1.etime, doc.mod1.freqlow, doc.mod1.freqhigh);
    for i=1:length(doc.mod1.regs)
        xy = doc.mod1.regs{i}.pos; g = doc.mod1.regs{i}.gain;
        
        if (doc.mod1.regs{i}.onoff)
            set(doc.mod1.regs{i}.patch, 'visible', 'on'); 
            plot_patch(xy, g);
        else
            set(doc.mod1.regs{i}.patch, 'visible', 'off');
        end
    end
    print(htmp,'-depsc2', 'mod1');
    saveas(gca, 'mod1.png', 'png');
    close(htmp);   
    
end

% show AIgram at Mod 2
if (strfind(str_list_view, 'mod2')) 
    axes(handles.plotMod2); cla reset; %position; 
    plot_AI_gram(doc.mod2.cur_aigram, doc.mod2.wavfile, doc.mod2.snr, 'novalue');
    for i=1:length(doc.mod2.regs)
        
        xy = doc.mod2.regs{i}.pos;
        g = doc.mod2.regs{i}.gain;

        doc.mod2.regs{i}.patch = plot_patch(xy, g);
        
        if (doc.mod2.regs{i}.onoff)
            set(doc.mod2.regs{i}.patch, 'visible', 'on'); 
        else
            set(doc.mod2.regs{i}.patch, 'visible', 'off');
        end
    end
    
    % save mod2 in an eps figure
    htmp = figure('Position',[50, 50, 400, 300], 'Visible', 'off'); 
    set(htmp,'PaperPositionMode','auto')
    plot_AI_gram(doc.mod2.cur_aigram, doc.mod2.wavfile, doc.mod2.snr, 'novalue');
    for i=1:length(doc.mod2.regs)
        xy = doc.mod2.regs{i}.pos;
        g = doc.mod2.regs{i}.gain;
        
        if (doc.mod2.regs{i}.onoff)
            set(doc.mod2.regs{i}.patch, 'visible', 'on'); 
            plot_patch(xy, g);
        else
            set(doc.mod2.regs{i}.patch, 'visible', 'off');
        end
    end    
    print(htmp,'-depsc2', 'mod2');
    close(htmp);  
    
end