function [handles] = resize_GUI_window(handles)
%UNTITLED2 Summary of this function goes here
%   Detailed explanation goes here
%setting sizes and positions of the panels:

try %only to avoid erroring on 'too small' error which is entirely trivial
    
figSizeIdeal = [1080, 715];
temp = get(handles.main, 'Position');
figSize = temp(3:4);

% Panels:
% 'EVENT GRAM' outer edge panel
leftPanPos = [15, 15, ((figSize(1)-45)/(figSizeIdeal(1)-30))*670, ...
    ((figSize(2)-30)/(figSizeIdeal(2)-30))*675];
% Mod panels' parent panel
rightPanPos = [leftPanPos(3)+30, 15, ((figSize(1)-45)/(figSizeIdeal(1)-45))*365, ...
    ((figSize(2)-30)/(figSizeIdeal(2)-30))*675];
%'EVENT GRAM' main panel
leftInsidePanPos = [5, 5, leftPanPos(3)-10, leftPanPos(4)-10];
% Mod B panel
rightLowPanPos = [5, 5, rightPanPos(3)-10, (rightPanPos(4)-19)/2];
% Mod A panel
rightHighPanPos = [5, rightLowPanPos(4)+14, rightPanPos(3)-10, (rightPanPos(4)-19)/2];

%% Setting positions for groups of buttons, controls, and axes:
%   Sets the [X, Y] pixel of the lower-left hand corner of the group
%   relative to the lower-left hand corner of the group's parent panel.

% Control menu with drop-down menus to OPEN an audio file
leftPanTopMenuPos = [20, leftInsidePanPos(4)-60];
    leftPanTopMenuHspace = 80; %horizontal spacing between members
    leftPanTopMenuVspace = 25; %vertical spacing between rows of members
    
% Control menu with sliders that adjust Time and SNR
leftPanBottomMenuPos = [20, 10];
    leftPanBottomMenuHspace = 40;
    leftPanBottomMenuVspace = 20;
    
% Main control button menu for Mod A    
%JBA: This raises the 8 buttons at the top by +4 pixels
rightHighPanMenuPos = [10, rightHighPanPos(4)-70+4];
    rightPanMenuHspace = 50;
    rightPanMenuVspace = 25;
    
% Contains Mod A's Play and Comp buttons    
rightHighPanPlayCompPos = [10, 10];
    rightPanPlayCompHspace = 50;
    
% Mod B's main control button menu and the play/comp positions are swapped:    
rightLowPanMenuPos = [10, 10-8]; %JBA: Move 8 buttons at bottom, down by 8 pixels
rightLowPanPlayCompPos = [10, rightHighPanPos(4)-40];

% Both Mod A and Mod B have their checkmark menu in the same place
rightPanChecksPos = [rightHighPanPos(3)-35, rightHighPanPos(4)-70];
    rightPanChecksVspace = 20;
    
% 'EVENT GRAM' graphics area with 4 axes and a play button
%   This code sizes the graphics area so that every axes has the same size
%   with the appropriate aspect ratio and a constant pixel width between
%   axes.
leftPanGraphicsPos = [50, 80, leftInsidePanPos(3)-100, leftInsidePanPos(4)-160];
if(leftPanGraphicsPos(3) < leftPanGraphicsPos(4)*1.3)
    leftPanGraphicsPos(2) = leftPanGraphicsPos(2) + (leftPanGraphicsPos(4) - (leftPanGraphicsPos(3)/1.3))/2;
    leftPanGraphicsPos(4) = leftPanGraphicsPos(3)/1.3;
elseif(leftPanGraphicsPos(3) > leftPanGraphicsPos(4)*1.3)
    leftPanGraphicsPos(1) = leftPanGraphicsPos(1) + (leftPanGraphicsPos(3) - (leftPanGraphicsPos(4)*1.3))/2;
    leftPanGraphicsPos(3) = leftPanGraphicsPos(4)*1.3;
end
leftPanGraphicsHspace = 50;
leftPanGraphicsVspace = 50; leftPanGraphicsPlaySpace = 15;
leftPanGraphicsAxesSize = [(leftPanGraphicsPos(3)-leftPanGraphicsHspace)/2, ...
                            (leftPanGraphicsPos(4)-leftPanGraphicsVspace)/2];

% Mod A and B axes placement and sizing:                        
rightPanGraphicsPos = [40, 60, rightHighPanPos(3)-80, rightHighPanPos(4)-140];
if(rightPanGraphicsPos(3) < rightPanGraphicsPos(4)*1.3)
    rightPanGraphicsPos(2) = rightPanGraphicsPos(2) + (rightPanGraphicsPos(4) - (rightPanGraphicsPos(3)/1.3))/2;
    rightPanGraphicsPos(4) = rightPanGraphicsPos(3)/1.3;
elseif(rightPanGraphicsPos(3) > rightPanGraphicsPos(4)*1.3)
    rightPanGraphicsPos(1) = rightPanGraphicsPos(1) + (rightPanGraphicsPos(3) - (rightPanGraphicsPos(4)*1.3))/2;
    rightPanGraphicsPos(3) = rightPanGraphicsPos(4)*1.3;
end
rightHighPanGraphicsPos = rightPanGraphicsPos;
rightLowPanGraphicsPos = rightPanGraphicsPos; %Mod B needs more room on the bottom:
    rightLowPanGraphicsPos(2) = rightLowPanPos(4) - (rightLowPanGraphicsPos(2)+rightLowPanGraphicsPos(4));



%% Placing every individual control object:
    %all placements of groups start at the top left-most object, move right
    %through the row, then jump to the next row's left-most object,
    %continuing until the group is fully placed. Just like reading English.
    %This code does not set sizes, only positions. Set sizes with the .fig
    %file.

%left panel top menu, 'EVENT GRAM' sound selection:
lptm_lbl1 = leftPanTopMenuPos + [leftPanTopMenuHspace*0, leftPanTopMenuVspace*1];
lptm_lbl2 = leftPanTopMenuPos + [leftPanTopMenuHspace*1, leftPanTopMenuVspace*1];
lptm_lbl3 = leftPanTopMenuPos + [leftPanTopMenuHspace*2, leftPanTopMenuVspace*1];
lptm_lbl4 = leftPanTopMenuPos + [leftPanTopMenuHspace*3, leftPanTopMenuVspace*1];
lptm_pop1 = leftPanTopMenuPos + [leftPanTopMenuHspace*0, 0];
lptm_pop2 = leftPanTopMenuPos + [leftPanTopMenuHspace*1, 0];
lptm_pop3 = leftPanTopMenuPos + [leftPanTopMenuHspace*2, 0];
lptm_pop4 = leftPanTopMenuPos + [leftPanTopMenuHspace*3, 0];
lptm_btn1 = leftPanTopMenuPos + [leftPanTopMenuHspace*4, 0];

%left panel bottom menu, 'EVENT GRAM' Time/SNR sliders:
lpbm_lbl1 = leftPanBottomMenuPos + [leftPanBottomMenuHspace*0, leftPanBottomMenuVspace*1];
lpbm_edit1= leftPanBottomMenuPos + [leftPanBottomMenuHspace*1, leftPanBottomMenuVspace*1];
lpbm_lbl2 = leftPanBottomMenuPos + [leftPanBottomMenuHspace*2, leftPanBottomMenuVspace*1];
lpbm_sld1 = leftPanBottomMenuPos + [leftPanBottomMenuHspace*3, leftPanBottomMenuVspace*1+5];
lpbm_lbl3 = leftPanBottomMenuPos + [leftPanBottomMenuHspace*0, 0];
lpbm_edit2= leftPanBottomMenuPos + [leftPanBottomMenuHspace*1, 0];
lpbm_lbl4 = leftPanBottomMenuPos + [leftPanBottomMenuHspace*2, 0];
lpbm_sld2 = leftPanBottomMenuPos + [leftPanBottomMenuHspace*3, 5];

%left panel graphics area, 'EVENT GRAM' axes and Play button:
lpga_axes1= leftPanGraphicsPos(1:2) + leftPanGraphicsAxesSize.*[0, 1] + [0, leftPanGraphicsVspace + leftPanGraphicsPlaySpace];
lpga_axes2 = leftPanGraphicsPos(1:2) + leftPanGraphicsAxesSize.*[1, 1] + [leftPanGraphicsHspace, leftPanGraphicsVspace + leftPanGraphicsPlaySpace];
lpga_btn1 = [leftPanPos(3) - 100, (leftPanPos(4)/2)-15];
lpga_axes3 = leftPanGraphicsPos(1:2);
lpga_axes4 = leftPanGraphicsPos(1:2) + leftPanGraphicsAxesSize.*[1, 0] + [leftPanGraphicsHspace, 0];

%right high panel menus, 'Mod A' main button menu:
rhpm_lbl1 = rightHighPanMenuPos + [rightPanMenuHspace*0, rightPanMenuVspace*1];
rhpm_btn1 = rightHighPanMenuPos + [rightPanMenuHspace*1, rightPanMenuVspace*1];
rhpm_btn2 = rightHighPanMenuPos + [rightPanMenuHspace*2, rightPanMenuVspace*1];
rhpm_btn3 = rightHighPanMenuPos + [rightPanMenuHspace*3, rightPanMenuVspace*1];
rhpm_btn4 = rightHighPanMenuPos + [rightPanMenuHspace*4, rightPanMenuVspace*1];
rhpm_btn5 = rightHighPanMenuPos + [rightPanMenuHspace*0, 0];
rhpm_btn6 = rightHighPanMenuPos + [rightPanMenuHspace*1, 0];
rhpm_btn7 = rightHighPanMenuPos + [rightPanMenuHspace*2, 0];
rhpm_btn8 = rightHighPanMenuPos + [rightPanMenuHspace*3, 0];
rhpm_btn9 = rightHighPanMenuPos + [rightPanMenuHspace*4, 0];

%right high panel play/comp, 'Mod A' play/comp buttons:
rhppc_btn1 = rightHighPanPlayCompPos;
rhppc_btn2 = rightHighPanPlayCompPos + [rightPanPlayCompHspace, 0];

%right high panel checks, 'Mod A' checkbox menu:
rhpc_btn1 = rightPanChecksPos - [0, rightPanChecksVspace*0];
rhpc_btn2 = rightPanChecksPos - [0, rightPanChecksVspace*1];
rhpc_chk1 = rightPanChecksPos - [0, rightPanChecksVspace*2];
rhpc_chk2 = rightPanChecksPos - [0, rightPanChecksVspace*3];
rhpc_chk3 = rightPanChecksPos - [0, rightPanChecksVspace*4];
rhpc_chk4 = rightPanChecksPos - [0, rightPanChecksVspace*5];
rhpc_chk5 = rightPanChecksPos - [0, rightPanChecksVspace*6];
rhpc_chk6 = rightPanChecksPos - [0, rightPanChecksVspace*7];
rhpc_chk7 = rightPanChecksPos - [0, rightPanChecksVspace*8];
rhpc_chk8 = rightPanChecksPos - [0, rightPanChecksVspace*9];

%right low panel menus, 'Mod B' main button menu:
rlpm_lbl1 = rightLowPanMenuPos + [rightPanMenuHspace*0, rightPanMenuVspace*1];
rlpm_btn1 = rightLowPanMenuPos + [rightPanMenuHspace*1, rightPanMenuVspace*1];
rlpm_btn2 = rightLowPanMenuPos + [rightPanMenuHspace*2, rightPanMenuVspace*1];
rlpm_btn3 = rightLowPanMenuPos + [rightPanMenuHspace*3, rightPanMenuVspace*1];
rlpm_btn4 = rightLowPanMenuPos + [rightPanMenuHspace*4, rightPanMenuVspace*1];
rlpm_btn5 = rightLowPanMenuPos + [rightPanMenuHspace*0, 0];
rlpm_btn6 = rightLowPanMenuPos + [rightPanMenuHspace*1, 0];
rlpm_btn7 = rightLowPanMenuPos + [rightPanMenuHspace*2, 0];
rlpm_btn8 = rightLowPanMenuPos + [rightPanMenuHspace*3, 0];
rlpm_btn9 = rightLowPanMenuPos + [rightPanMenuHspace*4, 0];

%right low panel play/comp, 'Mod B' play/comp buttons:
rlppc_btn1 = rightLowPanPlayCompPos;
rlppc_btn2 = rightLowPanPlayCompPos + [rightPanPlayCompHspace, 0];

%right low panel checks, 'Mod B' checkbox menu:
rlpc_btn1 = rightPanChecksPos - [0, rightPanChecksVspace*0];
rlpc_btn2 = rightPanChecksPos - [0, rightPanChecksVspace*1];
rlpc_chk1 = rightPanChecksPos - [0, rightPanChecksVspace*2];
rlpc_chk2 = rightPanChecksPos - [0, rightPanChecksVspace*3];
rlpc_chk3 = rightPanChecksPos - [0, rightPanChecksVspace*4];
rlpc_chk4 = rightPanChecksPos - [0, rightPanChecksVspace*5];
rlpc_chk5 = rightPanChecksPos - [0, rightPanChecksVspace*6];
rlpc_chk6 = rightPanChecksPos - [0, rightPanChecksVspace*7];
rlpc_chk7 = rightPanChecksPos - [0, rightPanChecksVspace*8];
rlpc_chk8 = rightPanChecksPos - [0, rightPanChecksVspace*9];

%right high and low panel graphics areas, 'Mod A' and 'Mod B' axes:
%unecessary, all information is inside of rightHighPanGraphicsPos and
%rightLowPanGraphicsPos


%% Assigning the positions to the existing control objects:
%   Uses the position variables in the previous code section to place every
%   control object. The set_new_position and set_new_full_position functions 
%   ensure the object is parented by the correct panel and reads its size 
%   and position in pixels. set_new_position only sets the position and
%   ignores sizing while set_new_full_position sets the object's position
%   and size.

%figure and parent panel placement:
set(handles.uipanelEventGram1, 'Position', leftPanPos);
set(handles.uipanelEventGram, 'Position', leftInsidePanPos);
set(handles.uipanelmod, 'Position', rightPanPos);
set(handles.uipanelmod1, 'Position', rightHighPanPos);
set(handles.uipanelmod2, 'Position', rightLowPanPos);

P = handles.uipanelEventGram; %set 'EVENT GRAM' parent for the following operations
%left panel top menu, 'EVENT GRAM':
handles.textExp = set_new_position(handles.textExp, P, lptm_lbl1);
handles.textTalker = set_new_position(handles.textTalker, P, lptm_lbl2);
handles.textCons = set_new_position(handles.textCons, P, lptm_lbl3);
handles.text25 = set_new_position(handles.text25, P, lptm_lbl4);
handles.popexp = set_new_position(handles.popexp, P, lptm_pop1);
handles.poptlk = set_new_position(handles.poptlk, P, lptm_pop2);
handles.popcons = set_new_position(handles.popcons, P, lptm_pop3);
handles.popvows = set_new_position(handles.popvows, P, lptm_pop4);
handles.butOpen = set_new_position(handles.butOpen, P, lptm_btn1);

%left panel bottom menu, 'EVENT GRAM':
handles.staticTime = set_new_position(handles.staticTime, P, lpbm_lbl1);
handles.staticSNR = set_new_position(handles.staticSNR, P, lpbm_lbl3);
handles.editTime = set_new_position(handles.editTime, P, lpbm_edit1);
handles.editSNR = set_new_position(handles.editSNR, P, lpbm_edit2);
handles.staticCS = set_new_position(handles.staticCS, P, lpbm_lbl2);
handles.staticdB = set_new_position(handles.staticdB, P, lpbm_lbl4);
handles.slideTime = set_new_position(handles.slideTime, P, lpbm_sld1);
handles.slideSNR = set_new_position(handles.slideSNR, P, lpbm_sld2);

%left panel graphics area, 'EVENT GRAM':
handles.plotAIgram = set_new_full_position(handles.plotAIgram, P, [lpga_axes1, leftPanGraphicsAxesSize]);
handles.plotEventGram = set_new_full_position(handles.plotEventGram, P, [lpga_axes2, leftPanGraphicsAxesSize]);
handles.butPlay = set_new_position(handles.butPlay, P, lpga_btn1);
handles.plotCC = set_new_full_position(handles.plotCC, P, [lpga_axes3, leftPanGraphicsAxesSize]);
handles.plotPI = set_new_full_position(handles.plotPI, P, [lpga_axes4, leftPanGraphicsAxesSize]);

%left panel editNtype in 'EVENT GRAM': (potentially useless box, remove?)
handles.editNtype = set_new_position(handles.editNtype, P, [leftPanPos(3)-60, 0]);

P = handles.uipanelmod1; %set 'Mod A' parent for the following operations
%right high panel menu, 'Mod A':
handles.mod1ntype = set_new_position(handles.mod1ntype, P, rhpm_lbl1);
handles.butreg1 = set_new_position(handles.butreg1, P, rhpm_btn1);
handles.butmod1 = set_new_position(handles.butmod1, P, rhpm_btn2);
handles.butundo1 = set_new_position(handles.butundo1, P, rhpm_btn3);
handles.butredo1 = set_new_position(handles.butredo1, P, rhpm_btn4);
handles.butUpdateMod1 = set_new_position(handles.butUpdateMod1, P, rhpm_btn5);
handles.butSet1 = set_new_position(handles.butSet1, P, rhpm_btn6);
handles.butreset1 = set_new_position(handles.butreset1, P, rhpm_btn7);
handles.butload1 = set_new_position(handles.butload1, P, rhpm_btn8);
handles.butsave1 = set_new_position(handles.butsave1, P, rhpm_btn9);

%right high panel play/comp, 'Mod A':
handles.butplay1 = set_new_position(handles.butplay1, P, rhppc_btn1);
handles.butComp1 = set_new_position(handles.butComp1, P, rhppc_btn2);

%right high panel checks, 'Mod A':
handles.butZoom1 = set_new_position(handles.butZoom1, P, rhpc_btn1);
handles.butPan1 = set_new_position(handles.butPan1, P, rhpc_btn2);
handles.mod1reg1 = set_new_position(handles.mod1reg1, P, rhpc_chk1);
handles.mod1reg2 = set_new_position(handles.mod1reg2, P, rhpc_chk2);
handles.mod1reg3 = set_new_position(handles.mod1reg3, P, rhpc_chk3);
handles.mod1reg4 = set_new_position(handles.mod1reg4, P, rhpc_chk4);
handles.mod1reg5 = set_new_position(handles.mod1reg5, P, rhpc_chk5);
handles.mod1reg6 = set_new_position(handles.mod1reg6, P, rhpc_chk6);
handles.mod1reg7 = set_new_position(handles.mod1reg7, P, rhpc_chk7);
handles.mod1reg8 = set_new_position(handles.mod1reg8, P, rhpc_chk8);

%right high panel graphics, 'Mod A':
handles.plotMod1 = set_new_full_position(handles.plotMod1, P, rightHighPanGraphicsPos);

P = handles.uipanelmod2; %set 'Mod B' parent for these operations
%right low panel menu, 'Mod B':
handles.mod2ntype = set_new_position(handles.mod2ntype, P, rlpm_lbl1);
handles.butreg2 = set_new_position(handles.butreg2, P, rlpm_btn1);
handles.butmod2 = set_new_position(handles.butmod2, P, rlpm_btn2);
handles.butundo2 = set_new_position(handles.butundo2, P, rlpm_btn3);
handles.butredo2 = set_new_position(handles.butredo2, P, rlpm_btn4);
handles.butUpdateMod2 = set_new_position(handles.butUpdateMod2, P, rlpm_btn5);
handles.butSet2 = set_new_position(handles.butSet2, P, rlpm_btn6);
handles.butreset2 = set_new_position(handles.butreset2, P, rlpm_btn7);
handles.butload2 = set_new_position(handles.butload2, P, rlpm_btn8);
handles.butsave2 = set_new_position(handles.butsave2, P, rlpm_btn9);

%right low panel play/comp, 'Mod B':
handles.butplay2 = set_new_position(handles.butplay2, P, rlppc_btn1);
handles.butComp2 = set_new_position(handles.butComp2, P, rlppc_btn2);

%right low panel checks, 'Mod B':
handles.butZoom2 = set_new_position(handles.butZoom2, P, rlpc_btn1);
handles.butPan2 = set_new_position(handles.butPan2, P, rlpc_btn2);
handles.mod2reg1 = set_new_position(handles.mod2reg1, P, rlpc_chk1);
handles.mod2reg2 = set_new_position(handles.mod2reg2, P, rlpc_chk2);
handles.mod2reg3 = set_new_position(handles.mod2reg3, P, rlpc_chk3);
handles.mod2reg4 = set_new_position(handles.mod2reg4, P, rlpc_chk4);
handles.mod2reg5 = set_new_position(handles.mod2reg5, P, rlpc_chk5);
handles.mod2reg6 = set_new_position(handles.mod2reg6, P, rlpc_chk6);
handles.mod2reg7 = set_new_position(handles.mod2reg7, P, rlpc_chk7);
handles.mod2reg8 = set_new_position(handles.mod2reg8, P, rlpc_chk8);

%right low panel graphics, 'Mod B':
handles.plotMod2 = set_new_full_position(handles.plotMod2, P, rightLowPanGraphicsPos);

catch
    
end

end

%function that sets the position of a uicontrol without affecting its size
%also ensures its parent is set appropriately before performing positioning
function [subHandle] = set_new_position(subHandle, parent, newPos)
    set(subHandle, 'Parent', parent);
    set(subHandle, 'Units', 'pixels');
    curPos = get(subHandle, 'Position');
    set(subHandle, 'Position', [newPos, curPos(3:4)]); 
end

%function that sets the position of a uicontrol, ensures its parent is set
%appropriately before performing positioning
function [subHandle] = set_new_full_position(subHandle, parent, newPos)
    set(subHandle, 'Parent', parent);
    set(subHandle, 'Units', 'pixels');
    set(subHandle, 'Position', newPos);
end
