%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This program extract the event_gram of a particular time from the AI cube 
% Input: AI_cube -- cube of the AIgram
%        t_star -- the time location for the event_gram
% Output: event_gram -- the event_gram of the designated time location
%   Author:      Feipeng Li revised from Marion's code
%   E-mail:      fli2@uiuc.edu
%   Time-stamp:  2007-06-05
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function event_gram = extract_event_gram(AI_cube, t_star)

% first test whether the time t_star is valid
start_time = min(AI_cube(1).time_axis);
end_time = max(AI_cube(1).time_axis);

event_gram = [];
if (t_star>=start_time)&&(t_star<=end_time)
    column_no = round((t_star-start_time)/(end_time-start_time)*length(AI_cube(1).time_axis));

    if column_no==0, column_no=1; end
    
    for i = 1:length(AI_cube)
        mega_ccgram(:,:,i)= AI_cube(i).ccgram;% create the mega cc for event_gram
    end
    
    event_gram = squeeze(mega_ccgram(:,column_no,:));
    event_gram = cancel_noise_breakthrough(event_gram);    
else
    disp('The input time t_star is invalid!');
end