%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This program automatically extract the time location for the feature 
% of t-burst by searching for the peaks in the time-variant cc.
% Input: AI_cube -- cube of the AIgram
%        snr -- signal-to-noise ratio associated with the AI-gram
% Output: t_star -- the time location for the event_gram
%   Author:      Feipeng Li revised from Marion's code
%   E-mail:      fli2@uiuc.edu
%   Time-stamp:  2007-06-05
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function t_star = find_t_burst(AI_cube, snr)

cc_of_interest = extract_cc(AI_cube, snr);

[lmval,indd]=lmax(cc_of_interest.data);% find the peaks in the CC

% get rid of the peaks below threshold, so far let's say it's 0.05 bits
x = find(lmval> 0.05);
lmval = lmval(x); indd = indd(x);

start_time = min(cc_of_interest.time_axis);
end_time = max(cc_of_interest.time_axis);

t_star = -1;
if ~isempty(indd)
    t_star_col = indd(1); 
    t_star = t_star_col/length(AI_cube(1).time_axis)*(end_time-start_time)+start_time;
end