%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This program is used to create MN16R_SndList.mat, which contains a list 
% all the utterances appeared in this experiment.
%   Author:      Feipeng Li at HSR, Beckman Institute, UIUC
%   Time-stamp:  2006-11-07
%   E-mail:      fli2@uiuc.edu
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function create_MN16R_SndList()

if exist('MN16R.mat')
    load MN16R.mat;
else
    pullNHdata('mn16rdata.zip');
    load MN16R.mat;
end

Talker_Stim = strrep(Talker_Stim, 'xd', 'D');
Talker_Stim = strrep(Talker_Stim, 'xt', 'T');
Talker_Stim = strrep(Talker_Stim, 'xs', 'S');
Talker_Stim = strrep(Talker_Stim, 'xz', 'Z');

for i=1:length(Talker_Stim)
    Talker{i} = Talker_Stim{i}(1:4);
    Consonant{i} = Talker_Stim{i}(6);
    Vowel{i} = Talker_Stim{i}(7:end);
end

Consonant = strrep(Consonant, 'D', 'xd');
Consonant = strrep(Consonant, 'T', 'xt');
Consonant = strrep(Consonant, 'S', 'xs');
Consonant = strrep(Consonant, 'Z', 'xz');

MN16R_SndList.tlk = Talker;
MN16R_SndList.con = Consonant;
MN16R_SndList.vow = Vowel;

save('MN16R_SndList.mat', 'MN16R_SndList');